require 'spec_helper'

class TestDSL < GraphQL::Rails::DSL
  attr_reader :value

  def initialize(value)
    @value = value
  end

  def add(value)
    @value += value
  end
end

describe GraphQL::Rails::DSL do
  let(:dsl) { TestDSL.new(0) }

  it 'resolves DSL instance variables' do
    dsl.run do
      expect(@value).to be 0
    end
  end

  it 'resolves DSL instance methods' do
    dsl.run do
      add 2
      add 4
    end
    expect(dsl.value).to be 6
  end

  def meaning_of_life
    42
  end

  it "resolves methods from the block's context" do
    dsl.run do
      add meaning_of_life
    end
    expect(dsl.value).to be meaning_of_life
  end
end
